diff --git a/gcc/cp/mapper-client.cc b/gcc/cp/mapper-client.cc
index 39e80df2d25..92727195246 100644
--- a/gcc/cp/mapper-client.cc
+++ b/gcc/cp/mapper-client.cc
@@ -34,6 +34,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "diagnostic-core.h"
 #include "mapper-client.h"
 #include "intl.h"
+#include "mkdeps.h"
 
 #include "../../c++tools/resolver.h"
 
@@ -132,6 +133,7 @@ spawn_mapper_program (char const **errmsg, std::string &name,
 
 module_client *
 module_client::open_module_client (location_t loc, const char *o,
+				   class mkdeps *deps,
 				   void (*set_repo) (const char *),
 				   char const *full_program_name)
 {
@@ -285,6 +287,9 @@ module_client::open_module_client (location_t loc, const char *o,
 	  errmsg = "opening";
 	else
 	  {
+	    /* Add the mapper file to the dependency tracking. */
+	    if (deps)
+	      deps_add_dep (deps, name.c_str ());
 	    if (int l = r->read_tuple_file (fd, ident, false))
 	      {
 		if (l > 0)
diff --git a/gcc/cp/mapper-client.h b/gcc/cp/mapper-client.h
index b32723ce296..a3b0b8adc51 100644
--- a/gcc/cp/mapper-client.h
+++ b/gcc/cp/mapper-client.h
@@ -55,6 +55,7 @@ public:
 
 public:
   static module_client *open_module_client (location_t loc, const char *option,
+					    class mkdeps *,
 					    void (*set_repo) (const char *),
 					    char const *);
   static void close_module_client (location_t loc, module_client *);
diff --git a/gcc/cp/module.cc b/gcc/cp/module.cc
index f3acc4e02fe..77c9edcbc04 100644
--- a/gcc/cp/module.cc
+++ b/gcc/cp/module.cc
@@ -3969,12 +3969,12 @@ static GTY(()) vec<tree, va_gc> *partial_specializations;
 /* Our module mapper (created lazily).  */
 module_client *mapper;
 
-static module_client *make_mapper (location_t loc);
-inline module_client *get_mapper (location_t loc)
+static module_client *make_mapper (location_t loc, class mkdeps *deps);
+inline module_client *get_mapper (location_t loc, class mkdeps *deps)
 {
   auto *res = mapper;
   if (!res)
-    res = make_mapper (loc);
+    res = make_mapper (loc, deps);
   return res;
 }
 
@@ -14033,7 +14033,7 @@ get_module (const char *ptr)
 /* Create a new mapper connecting to OPTION.  */
 
 module_client *
-make_mapper (location_t loc)
+make_mapper (location_t loc, class mkdeps *deps)
 {
   timevar_start (TV_MODULE_MAPPER);
   const char *option = module_mapper_name;
@@ -14041,7 +14041,7 @@ make_mapper (location_t loc)
     option = getenv ("CXX_MODULE_MAPPER");
 
   mapper = module_client::open_module_client
-    (loc, option, &set_cmi_repo,
+    (loc, option, deps, &set_cmi_repo,
      (save_decoded_options[0].opt_index == OPT_SPECIAL_program_name)
      && save_decoded_options[0].arg != progname
      ? save_decoded_options[0].arg : nullptr);
@@ -19506,7 +19506,7 @@ maybe_translate_include (cpp_reader *reader, line_maps *lmaps, location_t loc,
   dump.push (NULL);
 
   dump () && dump ("Checking include translation '%s'", path);
-  auto *mapper = get_mapper (cpp_main_loc (reader));
+  auto *mapper = get_mapper (cpp_main_loc (reader), cpp_get_deps (reader));
 
   size_t len = strlen (path);
   path = canonicalize_header_name (NULL, loc, true, path, len);
@@ -19622,7 +19622,7 @@ module_begin_main_file (cpp_reader *reader, line_maps *lmaps,
 static void
 name_pending_imports (cpp_reader *reader)
 {
-  auto *mapper = get_mapper (cpp_main_loc (reader));
+  auto *mapper = get_mapper (cpp_main_loc (reader), cpp_get_deps (reader));
 
   if (!vec_safe_length (pending_imports))
     /* Not doing anything.  */
@@ -20092,7 +20092,7 @@ init_modules (cpp_reader *reader)
 
   if (!flag_module_lazy)
     /* Get the mapper now, if we're not being lazy.  */
-    get_mapper (cpp_main_loc (reader));
+    get_mapper (cpp_main_loc (reader), cpp_get_deps (reader));
 
   if (!flag_preprocess_only)
     {
@@ -20302,7 +20302,7 @@ late_finish_module (cpp_reader *reader,  module_processing_cookie *cookie,
 
   if (!errorcount)
     {
-      auto *mapper = get_mapper (cpp_main_loc (reader));
+      auto *mapper = get_mapper (cpp_main_loc (reader), cpp_get_deps (reader));
       mapper->ModuleCompiled (state->get_flatname ());
     }
   else if (cookie->cmi_name)
diff --git a/gcc/testsuite/g++.dg/modules/depreport-2.modmap b/gcc/testsuite/g++.dg/modules/depreport-2.modmap
new file mode 100644
index 00000000000..ff271df883a
--- /dev/null
+++ b/gcc/testsuite/g++.dg/modules/depreport-2.modmap
@@ -0,0 +1,2 @@
+$root .
+Foo     Foo.gcm
diff --git a/gcc/testsuite/g++.dg/modules/depreport-2_a.C b/gcc/testsuite/g++.dg/modules/depreport-2_a.C
new file mode 100644
index 00000000000..6912de16333
--- /dev/null
+++ b/gcc/testsuite/g++.dg/modules/depreport-2_a.C
@@ -0,0 +1,15 @@
+// { dg-do preprocess }
+// { dg-additional-options -fmodules-ts }
+// { dg-additional-options -fmodule-mapper=[srcdir]/depreport-2.modmap }
+// { dg-additional-options -MD }
+// { dg-additional-options "-MF depreport-2_a.d" }
+
+export module Foo;
+
+export class Base
+{
+public:
+  int m;
+};
+
+// { dg-final { run-check-module-dep-expect-input "depreport-2_a.d" "[srcdir]/depreport-2.modmap" } }
diff --git a/gcc/testsuite/g++.dg/modules/depreport-2_b.C b/gcc/testsuite/g++.dg/modules/depreport-2_b.C
new file mode 100644
index 00000000000..d94d6a297a0
--- /dev/null
+++ b/gcc/testsuite/g++.dg/modules/depreport-2_b.C
@@ -0,0 +1,14 @@
+// { dg-do preprocess }
+// { dg-additional-options -fmodules-ts }
+// { dg-additional-options -fmodule-mapper=[srcdir]/depreport-2.modmap }
+// { dg-additional-options -MD }
+// { dg-additional-options "-MF depreport-2_b.d" }
+
+import Foo;
+
+void foo ()
+{
+  Base b;
+}
+
+// { dg-final { run-check-module-dep-expect-input "depreport-2_b.d" "[srcdir]/depreport-2.modmap" } }
diff --git a/gcc/testsuite/g++.dg/modules/test-depfile.py b/gcc/testsuite/g++.dg/modules/test-depfile.py
index ea4edb61434..9693c058ece 100644
--- a/gcc/testsuite/g++.dg/modules/test-depfile.py
+++ b/gcc/testsuite/g++.dg/modules/test-depfile.py
@@ -28,6 +28,11 @@ class Input(Token):
         self.path = path
 
 
+class OrderInput(Token):
+    def __init__(self, path):
+        self.path = path
+
+
 class Colon(Token):
     pass
 
@@ -89,6 +94,10 @@ def validate_depfile(depfile, expect_input=None):
             if word.endswith(':'):
                 tokenized.append(word[:-1])
                 word = word[-1]
+            # Detect `:` at the end of a word.
+            if word.endswith(':|'):
+                tokenized.append(word[:-2])
+                word = word[-2]
 
             # Add word to the tokenized set.
             tokenized.append(word)
@@ -104,6 +113,8 @@ def validate_depfile(depfile, expect_input=None):
                 kind = 'dependency'
             elif token == '+=':
                 kind = 'append'
+            elif token == ':|':
+                kind = 'order-only'
         if line == ['']:
             kind = 'empty'
 
@@ -120,6 +131,15 @@ def validate_depfile(depfile, expect_input=None):
                     line_parse.append(Input(token))
                 else:
                     line_parse.append(Output(token))
+        elif kind == 'order-only':
+            after_op = False
+            for token in line:
+                if token == ':|':
+                    after_op = True
+                elif after_op:
+                    line_parse.append(OrderInput(token))
+                else:
+                    line_parse.append(Output(token))
         elif kind == 'append':
             after_op = False
             for token in line: